;;  color.lsp. The Data Touring Machine. Copyright (C) 2004 Steve Eichblatt
;;
;;  This program is free software; you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation; either version 2 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program; if not, write to the Free Software
;;  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;;
;;  Contact: Steve Eichblatt
;;  620 E San Salvador San Jose, CA 95112. steve@eichblatt.us

(defpackage :datoura-color
           (:nicknames :color)
           (:use :common-lisp)
           (:export #:colorlist #:colornames))
(in-package :datoura-color)
;; this generates 143 warnings when compiled. I don't know how to declare
;; these names so that it doesn't complain.
(defun setcolors ()
(declare (special aliceblue antiquewhite aqua AQUAMARINE AZURE
          BEIGE BISQUE BLACK BLANCHEDALMOND BLUE BLUEVIOLET BROWN BURLYWOOD
          CADETBLUE CHARTREUSE CHOCOLATE CORAL CORNFLOWERBLUE CORNSILK CRIMSON
          CYAN DARKBLUE DARKCYAN DARKGOLDENROD DARKGRAY DARKGREEN DARKKHAKI 
          DARKMAGENTA DARKOLIVEGREEN DARKORANGE DARKORCHID 
          DARKRED DARKSALMON DARKSEAGREEN DARKSLATEBLUE DARKSLATEGRAY 
          DARKTURQUOISE DARKVIOLET DEEPPINK DEEPSKYBLUE DIMGRAY DODGERBLUE 
          FIREBRICK FLORALWHITE FORESTGREEN FUCHSIA GAINSBORO GHOSTWHITE GOLD 
          GOLDENROD GRAY GREEN GREENYELLOW HONEYDEW HOTPINK INDIANRED INDIGO IVORY 
          KHAKI LAVENDER LAVENDERBLUSH LAWNGREEN LEMONCHIFFON LIGHTBLUE LIGHTCORAL 
          LIGHTCYAN LIGHTGOLDENRODYELLOW LIGHTGREEN LIGHTGREY LIGHTPINK 
          LIGHTSALMON LIGHTSEAGREEN LIGHTSKYBLUE LIGHTSLATEGRAY LIGHTSTEELBLUE 
          LIGHTYELLOW LIME LIMEGREEN LINEN MAGENTA MAROON MEDIUMAQUAMARINE 
          MEDIUMBLUE MEDIUMORCHID MEDIUMPURPLE MEDIUMSEAGREEN MEDIUMSLATEBLUE 
          MEDIUMSPRINGGREEN MEDIUMTURQUOISE MEDIUMVIOLETRED MIDNIGHTBLUE MINTCREAM 
          MISTYROSE MOCCASIN NAVAJOWHITE NAVY OLDLACE OLIVE OLIVEDRAB ORANGE 
          ORANGERED ORCHID PALEGOLDENROD PALEGREEN PALETURQUOISE PALEVIOLETRED 
          PAPAYAWHIP PEACHPUFF PERU PINK PLUM POWDERBLUE PURPLE RED ROSYBROWN 
          ROYALBLUE SADDLEBROWN SALMON SANDYBROWN SEAGREEN SEASHELL SIENNA SILVER 
          SKYBLUE SLATEBLUE SLATEGRAY SNOW SPRINGGREEN STEELBLUE TAN TEAL THISTLE 
          TOMATO TURQUOISE VIOLET WHEAT WHITE WHITESMOKE YELLOW YELLOWGREEN
          colornames colorlist))
(setq
  ALICEBLUE '(0.9411765 0.972549 1.0)
  ANTIQUEWHITE '(0.98039216 0.92156863 0.84313726)
  AQUA '(0 1.0 1.0)
  AQUAMARINE '(0.49803922 1.0 0.83137256)
  AZURE '(0.9411765 1.0 1.0)
  BEIGE '(0.9607843 0.9607843 0.8627451)
  BISQUE '(1.0 0.89411765 0.76862746)
  BLACK '(0 0 0)
  BLANCHEDALMOND '(1.0 0.92156863 0.8039216)
  BLUE '(0 0 1.0)
  BLUEVIOLET '(0.5411765 0.16862746 0.8862745)
  BROWN '(0.64705884 0.16470589 0.16470589)
  BURLYWOOD '(0.87058824 0.72156864 0.5294118)
  CADETBLUE '(0.37254903 0.61960787 0.627451)
  CHARTREUSE '(0.49803922 1.0 0)
  CHOCOLATE '(0.8235294 0.4117647 0.11764706)
  CORAL '(1.0 0.49803922 0.3137255)
  CORNFLOWERBLUE '(0.39215687 0.58431375 0.92941177)
  CORNSILK '(1.0 0.972549 0.8627451)
  CRIMSON '(0.8627451 0.078431375 0.23529412)
  CYAN '(0 1.0 1.0)
  DARKBLUE '(0 0 0.54509807)
  DARKCYAN '(0 0.54509807 0.54509807)
  DARKGOLDENROD '(0.72156864 0.5254902 0.043137256)
  DARKGRAY '(0.6627451 0.6627451 0.6627451)
  DARKGREEN '(0 0.39215687 0)
  DARKKHAKI '(0.7411765 0.7176471 0.41960785)
  DARKMAGENTA '(0.54509807 0 0.54509807)
  DARKOLIVEGREEN '(0.33333334 0.41960785 0.18431373)
  DARKORANGE '(1.0 0.54901963 0)
  DARKORCHID '(0.6 0.19607843 0.8)
  DARKRED '(0.54509807 0 0)
  DARKSALMON '(0.9137255 0.5882353 0.47843137)
  DARKSEAGREEN '(0.56078434 0.7372549 0.56078434)
  DARKSLATEBLUE '(0.28235295 0.23921569 0.54509807)
  DARKSLATEGRAY '(0.18431373 0.30980393 0.30980393)
  DARKTURQUOISE '(0 0.80784315 0.81960785)
  DARKVIOLET '(0.5803922 0 0.827451)
  DEEPPINK '(1.0 0.078431375 0.5764706)
  DEEPSKYBLUE '(0 0.7490196 1.0)
  DIMGRAY '(0.4117647 0.4117647 0.4117647)
  DODGERBLUE '(0.11764706 0.5647059 1.0)
  FIREBRICK '(0.69803923 0.13333334 0.13333334)
  FLORALWHITE '(1.0 0.98039216 0.9411765)
  FORESTGREEN '(0.13333334 0.54509807 0.13333334)
  FUCHSIA '(1.0 0 1.0)
  GAINSBORO '(0.8627451 0.8627451 0.8627451)
  GHOSTWHITE '(0.972549 0.972549 1.0)
  GOLD '(1.0 0.84313726 0)
  GOLDENROD '(0.85490197 0.64705884 0.1254902)
  GRAY '(0.5019608 0.5019608 0.5019608)
  GREEN '(0 0.5019608 0)
  GREENYELLOW '(0.6784314 1.0 0.18431373)
  HONEYDEW '(0.9411765 1.0 0.9411765)
  HOTPINK '(1.0 0.4117647 0.7058824)
  INDIANRED '(0.8039216 0.36078432 0.36078432)
  INDIGO '(0.29411766 0 0.50980395)
  IVORY '(1.0 1.0 0.9411765)
  KHAKI '(0.9411765 0.9019608 0.54901963)
  LAVENDER '(0.9019608 0.9019608 0.98039216)
  LAVENDERBLUSH '(1.0 0.9411765 0.9607843)
  LAWNGREEN '(0.4862745 0.9882353 0)
  LEMONCHIFFON '(1.0 0.98039216 0.8039216)
  LIGHTBLUE '(0.6784314 0.84705883 0.9019608)
  LIGHTCORAL '(0.9411765 0.5019608 0.5019608)
  LIGHTCYAN '(0.8784314 1.0 1.0)
  LIGHTGOLDENRODYELLOW '(0.98039216 0.98039216 0.8235294)
  LIGHTGREEN '(0.5647059 0.93333334 0.5647059)
  LIGHTGREY '(0.827451 0.827451 0.827451)
  LIGHTPINK '(1.0 0.7137255 0.75686276)
  LIGHTSALMON '(1.0 0.627451 0.47843137)
  LIGHTSEAGREEN '(0.1254902 0.69803923 0.6666667)
  LIGHTSKYBLUE '(0.5294118 0.80784315 0.98039216)
  LIGHTSLATEGRAY '(0.46666667 0.53333336 0.6)
  LIGHTSTEELBLUE '(0.6901961 0.76862746 0.87058824)
  LIGHTYELLOW '(1.0 1.0 0.8784314)
  LIME '(0 1.0 0)
  LIMEGREEN '(0.19607843 0.8039216 0.19607843)
  LINEN '(0.98039216 0.9411765 0.9019608)
  MAGENTA '(1.0 0 1.0)
  MAROON '(0.5019608 0 0)
  MEDIUMAQUAMARINE '(0.4 0.8039216 0.6666667)
  MEDIUMBLUE '(0 0 0.8039216)
  MEDIUMORCHID '(0.7294118 0.33333334 0.827451)
  MEDIUMPURPLE '(0.5764706 0.4392157 0.85882354)
  MEDIUMSEAGREEN '(0.23529412 0.7019608 0.44313726)
  MEDIUMSLATEBLUE '(0.48235294 0.40784314 0.93333334)
  MEDIUMSPRINGGREEN '(0 0.98039216 0.6039216)
  MEDIUMTURQUOISE '(0.28235295 0.81960785 0.8)
  MEDIUMVIOLETRED '(0.78039217 0.08235294 0.52156866)
  MIDNIGHTBLUE '(0.09803922 0.09803922 0.4392157)
  MINTCREAM '(0.9607843 1.0 0.98039216)
  MISTYROSE '(1.0 0.89411765 0.88235295)
  MOCCASIN '(1.0 0.89411765 0.70980394)
  NAVAJOWHITE '(1.0 0.87058824 0.6784314)
  NAVY '(0 0 0.5019608)
  OLDLACE '(0.99215686 0.9607843 0.9019608)
  OLIVE '(0.5019608 0.5019608 0)
  OLIVEDRAB '(0.41960785 0.5568628 0.13725491)
  ORANGE '(1.0 0.64705884 0)
  ORANGERED '(1.0 0.27058825 0)
  ORCHID '(0.85490197 0.4392157 0.8392157)
  PALEGOLDENROD '(0.93333334 0.9098039 0.6666667)
  PALEGREEN '(0.59607846 0.9843137 0.59607846)
  PALETURQUOISE '(0.6862745 0.93333334 0.93333334)
  PALEVIOLETRED '(0.85882354 0.4392157 0.5764706)
  PAPAYAWHIP '(1.0 0.9372549 0.8352941)
  PEACHPUFF '(1.0 0.85490197 0.7254902)
  PERU '(0.8039216 0.52156866 0.24705882)
  PINK '(1.0 0.7529412 0.79607844)
  PLUM '(0.8666667 0.627451 0.8666667)
  POWDERBLUE '(0.6901961 0.8784314 0.9019608)
  PURPLE '(0.5019608 0 0.5019608)
  RED '(1.0 0 0)
  ROSYBROWN '(0.7372549 0.56078434 0.56078434)
  ROYALBLUE '(0.25490198 0.4117647 0.88235295)
  SADDLEBROWN '(0.54509807 0.27058825 0.07450981)
  SALMON '(0.98039216 0.5019608 0.44705883)
  SANDYBROWN '(0.95686275 0.6431373 0.3764706)
  SEAGREEN '(0.18039216 0.54509807 0.34117648)
  SEASHELL '(1.0 0.9607843 0.93333334)
  SIENNA '(0.627451 0.32156864 0.1764706)
  SILVER '(0.7529412 0.7529412 0.7529412)
  SKYBLUE '(0.5294118 0.80784315 0.92156863)
  SLATEBLUE '(0.41568628 0.3529412 0.8039216)
  SLATEGRAY '(0.4392157 0.5019608 0.5647059)
  SNOW '(1.0 0.98039216 0.98039216)
  SPRINGGREEN '(0 1.0 0.49803922)
  STEELBLUE '(0.27450982 0.50980395 0.7058824)
  TAN '(0.8235294 0.7058824 0.54901963)
  TEAL '(0 0.5019608 0.5019608)
  THISTLE '(0.84705883 0.7490196 0.84705883)
  TOMATO '(1.0 0.3882353 0.2784314)
  TURQUOISE '(0.2509804 0.8784314 0.8156863)
  VIOLET '(0.93333334 0.50980395 0.93333334)
  WHEAT '(0.9607843 0.87058824 0.7019608)
  WHITE '(1.0 1.0 1.0)
  WHITESMOKE '(0.9607843 0.9607843 0.9607843)
  YELLOW '(1.0 1.0 0)
  YELLOWGREEN '(0.6039216 0.8039216 0.19607843)
)
  (setf 
  colornames '(    ;; put the list of colors in the order I want.
  BLACK RED GREEN BLUE PURPLE ORANGE YELLOW GRAY DARKRED INDIANRED 
  MEDIUMVIOLETRED ORANGERED PALEVIOLETRED DARKORANGE GREENYELLOW 
  LIGHTGOLDENRODYELLOW LIGHTYELLOW YELLOWGREEN DARKGREEN DARKOLIVEGREEN 
  DARKSEAGREEN FORESTGREEN LAWNGREEN LIGHTGREEN LIGHTSEAGREEN LIMEGREEN 
  MEDIUMSEAGREEN MEDIUMSPRINGGREEN PALEGREEN SEAGREEN SPRINGGREEN ALICEBLUE 
  BLUEVIOLET CADETBLUE CORNFLOWERBLUE DARKBLUE DARKSLATEBLUE DEEPSKYBLUE DODGERBLUE 
  LIGHTBLUE LIGHTSKYBLUE LIGHTSTEELBLUE MEDIUMBLUE MEDIUMSLATEBLUE MIDNIGHTBLUE 
  POWDERBLUE ROYALBLUE SKYBLUE SLATEBLUE STEELBLUE INDIGO MEDIUMPURPLE 
  DARKVIOLET VIOLET DARKGRAY DARKSLATEGRAY DIMGRAY LIGHTSLATEGRAY SLATEGRAY 
  ANTIQUEWHITE AQUA AQUAMARINE AZURE BEIGE BISQUE BLANCHEDALMOND BROWN 
  BURLYWOOD CHARTREUSE CHOCOLATE CORAL CORNSILK CRIMSON CYAN DARKCYAN DARKGOLDENROD 
  DARKKHAKI DARKMAGENTA DARKORCHID DARKSALMON DARKTURQUOISE DEEPPINK 
  FIREBRICK FLORALWHITE FUCHSIA GAINSBORO GHOSTWHITE GOLD GOLDENROD HONEYDEW 
  HOTPINK IVORY KHAKI LAVENDER LAVENDERBLUSH LEMONCHIFFON LIGHTCORAL LIGHTCYAN 
  LIGHTGREY LIGHTPINK LIGHTSALMON LIME LINEN MAGENTA MAROON MEDIUMAQUAMARINE 
  MEDIUMORCHID MEDIUMTURQUOISE MINTCREAM MISTYROSE MOCCASIN NAVAJOWHITE NAVY 
  OLDLACE OLIVE OLIVEDRAB ORCHID PALEGOLDENROD PALETURQUOISE PAPAYAWHIP PEACHPUFF 
  PERU PINK PLUM ROSYBROWN SADDLEBROWN SALMON SANDYBROWN SEASHELL SIENNA SILVER 
  SNOW TAN TEAL THISTLE TOMATO TURQUOISE WHEAT WHITE WHITESMOKE )
  )
;; the value of the colors in the list of names (in that order).

  (setf colorlist (mapcar #'eval colornames)))
(setcolors)
#|
  (setf 
  red-names '(RED DARKRED INDIANRED MEDIUMVIOLETRED ORANGERED PALEVIOLETRED 
         CRIMSON FIREBRICK TOMATO)
  orange-names '(ORANGE GOLDENROD DARKORANGE PERU)
  yellow-names '(YELLOW GOLD KHAKI PALEGOLDENROD MOCCASIN NAVAJOWHITE)
  green-names '(GREEN CHARTREUSE OLIVE OLIVEDRAB TEAL GREENYELLOW 
         DARKGREEN DARKOLIVEGREEN DARKSEAGREEN FORESTGREEN LAWNGREEN 
         LIGHTGREEN LIGHTSEAGREEN LIMEGREEN MEDIUMSEAGREEN MEDIUMSPRINGGREEN 
         PALEGREEN SEAGREEN SPRINGGREEN YELLOWGREEN LIME)
  blue-names '(BLUE BLUEVIOLET CADETBLUE CORNFLOWERBLUE DARKBLUE 
         DARKSLATEBLUE DEEPSKYBLUE DODGERBLUE LIGHTBLUE LIGHTSKYBLUE 
         LIGHTSTEELBLUE MEDIUMBLUE MEDIUMSLATEBLUE MIDNIGHTBLUE POWDERBLUE 
         ROYALBLUE SKYBLUE SLATEBLUE STEELBLUE AQUA AQUAMARINE CYAN NAVY
         DARKTURQUOISE MEDIUMTURQUOISE PALETURQUOISE TURQUOISE DARKCYAN
         MEDIUMAQUAMARINE)
  purple-names '(PURPLE INDIGO MEDIUMPURPLE DARKVIOLET VIOLET PLUM 
         DARKMAGENTA DARKORCHID FUCHSIA MAGENTA MEDIUMORCHID ORCHID )
  gray-names '(GRAY DARKGRAY DARKSLATEGRAY DIMGRAY LIGHTSLATEGRAY SLATEGRAY
         SILVER BLACK)
  pink-names '(PINK DEEPPINK HOTPINK LIGHTCORAL LIGHTPINK)
  brown-names '(BROWN CORAL DARKGOLDENROD DARKSALMON LIGHTSALMON MAROON SADDLEBROWN
           SIENNA ROSYBROWN SALMON SANDYBROWN TAN CHOCOLATE BURLYWOOD DARKKHAKI)
  white-names '(white aliceblue antiquewhite azure beige bisque blanchedalmond
           cornsilk floralwhite gainsboro ghostwhite honeydew ivory lavender 
           lavenderblush lemonchiffon lightcyan lightgoldenrodyellow lightgrey 
           lightyellow linen mintcream mistyrose oldlace papayawhip seashell snow
           whitesmoke wheat PEACHPUFF THISTLE)
)

(setf  
  reds    (mapcar #'eval red-names)  
  oranges (mapcar #'eval orange-names)  
  yellows (mapcar #'eval yellow-names)  
  greens  (mapcar #'eval green-names)  
  blues   (mapcar #'eval blue-names)  
  purples (mapcar #'eval purple-names)  
  grays   (mapcar #'eval gray-names)  
  pinks   (mapcar #'eval pink-names)  
  browns  (mapcar #'eval brown-names)  
  whites  (mapcar #'eval white-names)  
)
|#
#|
(setf mosaic ()) 
(dotimes (k (length colorlist) mosaic ) 
  (push (rectangle `((,(floor k 10) ,(mod k 10)) (1 1)) '((rec-type . "rectfill"))) 
         mosaic) 
  (push (plot::set-color (elt colorlist k)) mosaic))
;; show the mosaic
|#
