#!/usr/local/bin/clisp
(load "./datoura")
;
(in-package :datoura)
(setq filename "test.csv")
(setq sleeptime 5)
(setq help nil)

#|
;; ---------------------------------------------------------- cmd-args
;; I bet i could make this into a really slick macro
                                                                                
(defun cmd-args ()
  "Process the Command line arguments... This ought to be a macro"
(let ((args (cdr *args*)))
  (loop
    (cond ((null args) (return))
          ((equal (car args) "-f")
             (setq args (cdr args))
             (setq filename (car args)))
          ((equal (car args) "-t")
             (setq args (cdr args))
             (setq sleeptime (car args)))
          ((equal (car args) "-h")
             (setq help t))
          (t (format t "Unrecognized Argument ~s~%" (car args)))
     )
    (setq args (cdr args)))))  

;;; ---------------------------------------------------------- main routine

(cmd-args)
(format t "filename ~s~%" filename)
(if help (format t "Usage: ~s [-f filename] [-h]~%" (car *args*)))
|#

(setf dt (dtable-import filename))  ; loads the file into dtable structure
(print dt)
;(get-col dt 'player_id)             ; extract a single column 
;(get-cols dt '(year lgid))        ; extract multiple columns 
(group dt '(year lgid))           ; form a group
;(print-hash (dtable-groups dt))     
;(setf fcol (formula-col dt #'(lambda (h w) (and h w (+ h w))) '(height weight))) 
;(print fcol)

(print-hash (get-stats-by dt 'sorate '(throws))) ; strikeout rate by handedness.
(print "here")
(dtable-sort dt '((salary >) height (weight >)) '(1 1 1)) ; sorts by cols asc,descending
(print "here")
(fresh-line)
(dotimes (k 5) 
  (format t "~A~%" (get-obs dt k)))

;; first plot example

(show (scatter-by dt '(sorate salary) '(throws) :where '(< salary 200000))) 
(sleep sleeptime)

(setf hw (get-cols dt '(height weight)))
(setf hs (get-cols dt '(height salary)))

(setf h (histogram (kill-nil (get-col dt 'sorate)) 
        :options '((xlabel . "strike out rate")(ylabel . "N"))))
(show h)
(sleep sleeptime)
(show (histogram (get-col dt 'sorate) 
        :options '((binwidth . 1)(xlabel . "strike out rate")(ylabel . "N"))))

(sleep sleeptime)
(show (histogram (get-col dt 'salary) 
        :color color::firebrick :line t
        :options '((xlabel . "salary")(ylabel . "N"))))

(sleep sleeptime)
(show (scatter-plot (thread (first hw) (second hw)) 
    :color color::blue :symbol :mdsqe :profile t
    :options '((title . "Height vs. Weight of Major Leaguers") 
    (xlabel . "height (in)") (ylabel . "weight (lb)"))))

(sleep sleeptime)

;; An example of 2 plots superposed, with a common x axis and different y axes. 
(setf hist (histogram (dt-project dt 'sorate) 
  :color color::magenta :fill t
  :options '((xlabel . "Strikeout Rate") (ylabel . "N") (yaxis . :y1))))
(setf hist2 (histogram (dt-project dt 'sorate) :options '((yaxis . :y1))))
  
(setf cdf (scatter-plot (cdf (dt-project dt 'sorate) :normalize 1)))
(show (glist-append hist cdf hist2))

(sleep sleeptime)

(setf hhh (dt-project-by dt 'sorate '(bats) :where '(> sorate 5)))
(print-keys hhh)

(setf hl () colornum -1)
(maphash #'(lambda (key val) 
    (setf hl 
      (glist-append (histogram val :name key :color (elt colorlist (incf colornum)) :line t) hl))) hhh)
(show hl)

(sleep sleeptime)
(show (plot-cdf dt '(+ height (random 5.0)) :by '(bats)))

(sleep sleeptime)
(load "graphics/USmapPlot")
(show usmap '((xsize . 600)(ysize . 400)(show-axes . nil)(margin . ((:x0 . (.02 .98))(:y0 . (.02 .98))))))

(rewind 8)
(dotimes (k 8) (sleep .5) (ffwd 1))

(load "usmap/usa.lisp")
                                                                         
(setf movie (make-glist))
(glist-add movie (stretch-point 13000 -500) (stretch-point 1000 -7100))
(maphash #'(lambda (k v)
  (show
    (glist-add movie (set-color color::green)
       (state-polygon k '(fill . t))
       (unset-color)
       (state-polygon k))
    '((show-axes . nil)(xsize . 600)(ysize . 400)
       (margin . ((:x0 . (.02 .98))(:y0 . (.02 .98))))))
  (sleep 1)) us-states)

;;(cleanup)
