;;  ps-prolog.lsp. The Data Touring Machine. Copyright (C) 2004 Steve Eichblatt
;;
;;  This program is free software; you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation; either version 2 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program; if not, write to the Free Software
;;  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;;
;;  Contact: Steve Eichblatt
;;  620 E San Salvador San Jose, CA 95112. steve@eichblatt.us

;; ------------------------------------------------------ write-prolog
(defun write-prolog (xsize ysize)
  "write-prolog (xsize ysize) -- write the postscript prolog 
  to the graphics-terminal."
  (let ((prolog
"%!PS-Adobe-2.1 EPSF-2.1
%%BoundingBox:  0 0 ~D ~D
%%Title: ~A
%%Creator: Datoura Graphics Generator
%% April 2004
%% redistributable under the terms of the GNU General Public License
%%EndComments
%%BeginProlog

/circle { 0 360 arc stroke } def
/disk   { 0 360 arc fill   } def
                                                                                
/smpt { 1.0 disk } def
/mdpt { 2.0 disk } def
/lgpt { 3.0 disk } def
/hgpt { 5.0 disk } def
                                                                                
/smcr { 1.0 circle } def
/mdcr { 2.0 circle } def
/lgcr { 3.0 circle } def
/hgcr { 5.0 circle } def

/smsq { newpath moveto -1 -1 rmoveto 2 0 rlineto
        0 2 rlineto -2 0 rlineto closepath fill } def
/mdsq { newpath moveto -2 -2 rmoveto 4 0 rlineto
        0 4 rlineto -4 0 rlineto closepath fill } def
/lgsq { newpath moveto -3.5 -3.5 rmoveto 7 0 rlineto
        0 7 rlineto -7 0 rlineto closepath fill } def
/hgsq { newpath moveto -5 -5 rmoveto 10 0 rlineto
        0 10 rlineto -10 0 rlineto closepath fill } def

/smsqe { newpath moveto -1 -1 rmoveto 2 0 rlineto
         0 2 rlineto -2 0 rlineto closepath stroke } def
/mdsqe { newpath moveto -2 -2 rmoveto 4 0 rlineto
         0 4 rlineto -4 0 rlineto closepath stroke } def
/lgsqe { newpath moveto -3.5 -3.5 rmoveto 7 0 rlineto
         0 7 rlineto -7 0 rlineto closepath stroke } def
/hgsqe { newpath moveto -5 -5 rmoveto 10 0 rlineto
         0 10 rlineto -10 0 rlineto closepath stroke } def

/diamond {newpath 2 div exch 2 div exch
                  3 index 2 index sub
                  3 index moveto
                  2 copy rlineto 2 copy neg rlineto
                  2 copy neg exch neg exch rlineto
                  closepath stroke pop pop pop pop} def

/centerRect { 4 2 roll 2 index 2. div sub exch 3 index 2. div 
              sub exch 4 2 roll } def
/rectcent { centerRect rectstroke } def            
/rectcentfill { centerRect rectfill } def

% text right justified, left justified, centered.
% should i wrap these in a gsave / grestore ?
% Usage: x y angle string trj
/trj { gsave 3 index 3 index moveto 1 index rotate dup stringwidth pop
       neg 0 rmoveto show pop pop pop grestore} def
/tlj { gsave 3 index 3 index moveto 1 index rotate show
       pop pop pop grestore } def
/tcj { gsave 3 index 3 index moveto 1 index rotate dup stringwidth pop
       2 div neg 0 rmoveto show pop pop pop grestore } def

/exch12 { exch 3 1 roll } def

% horizcenter -- shift text to be centered horizontally. (even when rotated)
/horizcenter { gsave newpath 0 0 moveto dup false charpath 
       pathbbox closepath
       4 1 roll pop pop pop dup 3 index sin 4 index cos
       exch12 mul 2 div 3 1 roll mul 2 div
       5 index exch add exch 4 index exch sub 3 index 3 index
       mark 9 5 roll cleartomark grestore
       } def

% horiztop -- shift text to be on top. (even when rotated)
/horiztop { gsave newpath 0 0 moveto dup false charpath 
       pathbbox closepath
       4 1 roll pop pop pop dup 3 index sin 4 index cos
       exch12 mul 3 1 roll mul 
       5 index exch add exch 4 index exch sub 3 index 3 index
       mark 9 5 roll cleartomark grestore
       } def

/tcc { horizcenter tcj } def    % text centered horizontally
/trc { horizcenter trj } def
/tlc { horizcenter tlj } def

/tct { horiztop tcj } def       % text aligned at top edge.
/trt { horiztop trj } def
/tlt { horiztop tlj } def

% set a default font and size
/fsd {findfont exch scalefont def} bind def
/fss {findfont exch scalefont setfont} bind def
/sms {setfont moveto show} bind def
/ms  {moveto show} bind def
/times-roman       { /Times-Roman findfont 12 scalefont setfont} def
/times-roman-small { /Times-Roman findfont 10 scalefont setfont} def
/times-roman-large { /Times-Roman findfont 15 scalefont setfont} def

/swiss-n     { /Helvetica findfont exch scalefont setfont } def
/swiss       { 10 swiss-n} def
/swiss-small {  9 swiss-n} def
/swiss-tiny  {  3 swiss-n} def
/swiss-large { 12 swiss-n} def
/fixed-n     { /Courier findfont exch scalefont setfont } def
/fixed       { 10 fixed-n} def
/fixed-small {  7 fixed-n} def
/fixed-tiny  {  5 fixed-n} def
/fixed-large { 12 fixed-n} def
/fixed-huge  { 15 fixed-n} def

times-roman
%%EndProlog
"))
   (with-open-file (gout *graphics-terminal* 
              :direction :output :if-exists :supersede)
     (format gout prolog (round xsize) (round ysize) *graphics-terminal*))))
